luaL_error(LS, PAnsiChar(AnsiString(c)), []);

static int DcmQuery(DICOMDataObject *DDO, const char *Level, Array < DICOMDataObject  *> *pADDO, char *AE)
	{
        char *param = strchr(AE, ',');
        if (param) *param++ = 0;

	unsigned char 	ip[64], port[64], compress[64], SOP[66];
	LE_UINT16	command, datasettype, messageid, priority;
	int		i;

	PDU_Service	PDU;
	PDU.AttachRTC(&VRType);

	if(!GetACRNema(AE, (char *)ip, (char *)port, (char *)compress))
		return 0;

	// Start setting up connection for C-FIND
	PDU.ClearAbstractSyntaxs();
	PDU.SetLocalAddress(MYACRNEMA);
	PDU.SetRemoteAddress((unsigned char *)AE);

	uid.Set("1.2.840.10008.3.1.1.1");	// Application context (DICOM App)
	PDU.SetApplicationContext(uid);

	uid.Set("1.2.840.10008.5.1.4.1.2.1.1"); // PatientRootQuery
	PDU.AddAbstractSyntax(uid);
	uid.Set("1.2.840.10008.5.1.4.1.2.2.1"); // StudyRootQuery
	PDU.AddAbstractSyntax(uid);

	PDU.SetTimeOut(TCPIPTimeOut);

	// Make the association for the FIND on port/ip
	if(!PDU.Connect(ip, port))
		{
		OperatorConsole.printf("*** Virtual query - failed to connect for C-FIND to %s\n", AE);
		return ( 0 );
		}

	// Start a Patient/StudyRootQuery

	if (level==1) strcpy((char*) SOP, "1.2.840.10008.5.1.4.1.2.1.1"); // PatientRootQuery
	else          strcpy((char*) SOP, "1.2.840.10008.5.1.4.1.2.2.1"); // StudyRootQuery

	vr = new VR (0x0000, 0x0002, strlen((char*)SOP), (void*) SOP, FALSE);
	DCO.Push(vr);
	command = 0x0020;
	vr = new VR (0x0000, 0x0100, 0x0002, &command, FALSE);
	DCO.Push(vr);
	priority = 0;	// MEDIUM
	vr = new VR (0x0000, 0x0700, 0x0002, &priority, FALSE);
	DCO.Push(vr);
	datasettype = 0x0102;	
	vr = new VR (0x0000, 0x0800, 0x0002, &datasettype, FALSE);
	DCO.Push(vr);
	messageid = 0x0003;
	vr = new VR (0x0000, 0x0110, 0x0002, &messageid, FALSE);
	DCO.Push(vr);

	DDOPtr->ChangeVR(0x0008, 0x0052, Level, 'CS', TRUE);

	vr = DDOPtr->GetVR(0x0002, 0x0010); // delete transfer syntax
	if (vr) DDOPtr->DeleteVR(vr);

	// Here fixkodak fiximage should operate adding 0 to e.g., 9901234 patient ID
	if (param)
		if (strstr(param, "FIXKODAK") || strstr(param, "fixkodak"))
			KodakFixer(DDOPtr, TRUE);

	MyPatientRootQuery mq;
	MyStudyRootQuery sq;
	unsigned int s=pADDO->GetSize();
	
	if (strcmp(Level, "PATIENT")==0) mq.Write(&PDU, DDOPtr, pADDO);
	else          			 sq.Write(&PDU, DDOPtr, pADDO);
	
	PDU.Close();

	for (i=s; i<pADDO->GetSize(); i++)
		if (param)
			if (strstr(param, "FIXKODAK") || strstr(param, "fixkodak"))
				KodakFixer(pADDO->Get(i), FALSE);

	return pADDO->GetSize() - s;
	}

// move data from this to other server controlled by DICOMDataObject

static BOOL DcmMove(char* pszSourceAE, const char* pszDestinationAE, BOOL patroot, int id, DICOMDataObject *DDO, const char *callback)
{	PDU_Service		PDU;
	DICOMCommandObject	DCO;
	DICOMCommandObject	DCOR;
	DICOMDataObject		DDOR;
	UID			uid;
	VR			*vr;
	LE_UINT16		command, datasettype, messageid, priority;
	BYTE			SOP[64], AppTitle[64], host[64], port[64], compr[64];
	BOOL			rc = FALSE;

	if (strcmp(pszSourceAE, "(local)")==0)
  	  pszSourceAE = (char *)MYACRNEMA;

	PDU.AttachRTC(&VRType);

	PDU.ClearAbstractSyntaxs();
	PDU.SetLocalAddress((unsigned char*)MYACRNEMA);
	PDU.SetRemoteAddress((unsigned char*)pszSourceAE);

	uid.Set("1.2.840.10008.3.1.1.1");	// Application context (DICOM App)
	PDU.SetApplicationContext(uid);
	uid.Set("1.2.840.10008.5.1.4.1.2.1.2");	// patientrootmove
	PDU.AddAbstractSyntax(uid);
	uid.Set("1.2.840.10008.5.1.4.1.2.2.2");	// studyrootmove
	PDU.AddAbstractSyntax(uid);

	if (strcmp(pszSourceAE, (char *)MYACRNEMA)==0)
		{
		if(!PDU.Connect((BYTE *)"127.0.0.1", Port)) 
			{
			OperatorConsole.printf("***dicommove: local server not working\n");
			sprintf(StatusString, "***dicommove: local server not working");
			return FALSE;	// self not working: no retry
			}
		messageid = id;
		}
	else
		{
		if(!GetACRNema(pszSourceAE, (char *)host, (char *)port, (char *)compr)) 
			{
			OperatorConsole.printf("***dicommove: AE not found: %s\n", pszSourceAE);
			sprintf(StatusString, "***dicommove: AE not found: %s", pszSourceAE);
			return FALSE; 	// wrong address no retry
			}
		if(!PDU.Connect(host, port)) 
			{
			OperatorConsole.printf("***dicommove: could not connect to AE: %s\n", pszSourceAE);
			sprintf(StatusString, "***dicommove: could not connect to AE: %s", pszSourceAE);
			return TRUE;	// remote not working: retry
			}
		messageid = id;	// special to indicate move to itself - no import/exportconverters
		}

	if (patroot) 
          sprintf((char*) SOP, "1.2.840.10008.5.1.4.1.2.1.2"); // patient-root move
	else 
          sprintf((char*) SOP, "1.2.840.10008.5.1.4.1.2.2.2");  // study-root move
	
	vr = new VR (0x0000, 0x0002, strlen((char*)SOP), (void*) SOP, FALSE);
	DCO.Push(vr);
	command = 0x0021;
	vr = new VR (0x0000, 0x0100, 0x0002, &command, FALSE);
	DCO.Push(vr);
	priority = 0;
	vr = new VR (0x0000, 0x0700, 0x0002, &priority, FALSE);
	DCO.Push(vr);
	datasettype = 0x0102;	
	vr = new VR (0x0000, 0x0800, 0x0002, &datasettype, FALSE);
	DCO.Push(vr);

	vr = new VR (0x0000, 0x0110, 0x0002, &messageid, FALSE);
	DCO.Push(vr);

	memset((char*)AppTitle, ' ', 20);
	memcpy((void*)AppTitle, pszDestinationAE, strlen(pszDestinationAE));
	vr = new VR(0x0000, 0x0600, 16, (void*)&AppTitle[0], FALSE);
	DCO.Push(vr);

	uid.Set(SOP);
	PDU.Write(&DCO, uid);
	PDU.Write(DDO, uid);
	
	while(TRUE)
		{
		if(!PDU.Read(&DCOR))
			{
			OperatorConsole.printf("***dicommove: association lost\n");
			sprintf(StatusString, "***dicommove: association lost");
			return TRUE;	// associate lost: may retry
			}

		if(DCOR.GetUINT16(0x0000, 0x0100)!=0x8021)
			{
			OperatorConsole.printf("***dicommove: invalid C-move response\n");
			sprintf(StatusString, "***dicommove: invalid C-move response");
			rc = FALSE;
			goto EXIT; 	// not a C-MOVE-RSP ? no retry
			}
		
		if(DCOR.GetUINT16(0x0000, 0x0800)!=0x0101)
			{	
			PDU.Read(&DDOR);// ignore the data set
			DDOR.Reset();
			}

		if(DCOR.GetUINT16(0x0000, 0x0900)==0x0000)
			{
			rc = FALSE;
			*StatusString=0;
			goto EXIT;	// completed OK, no retry
			}
		else if (DCOR.GetUINT16(0x0000, 0x0900)==0xff00)
			{		// continuing no problem
			int iNbSent = DCOR.GetUINT16(0x0000, 0x1021);
			int iNbToGo = DCOR.GetUINT16(0x0000, 0x1020);
			sprintf(StatusString, "dicommove: %d of %d images transferred", iNbSent, iNbSent+iNbToGo);

			if (callback && *callback)
				{
				struct scriptdata sd = {&globalPDU, &DCOR, NULL, -1, NULL, NULL, NULL, NULL, NULL, 0};
				do_lua(&(globalPDU.L), (char *)callback, &sd);
				if (sd.DDO) delete sd.DDO;
				}

			DCOR.Reset();
			continue;
			}
		else
			{
			OperatorConsole.printf("***dicommove: remote DICOM error\n");
			sprintf(StatusString, "***dicommove: remote DICOM error");
			rc = FALSE;	// remote DICOM error: NO retry FOR NOW
			goto EXIT;
			}
		DCOR.Reset();
		}
EXIT:
	PDU.Close();
	return rc;
}

int SearchDICOMObject(DICOMObject *DDO, const char *desc, char *result, Array < DICOMDataObject * > **A, DICOMDataObject **O)
	{
	DICOMObject	DDO2;
	VR		*vr;
	int		i, g, e, len;
	unsigned int	Index;
//	char		*p;
	BOOL		seq=FALSE, wild=FALSE;

	if (A) *A = NULL;
	if (O) *O = NULL;

	result[0]=0;
	result[1]=0;	// indicates VR not found
	i      =0;

        if (desc[i]=='(')
		{
		i++;
		char r[300];
		DICOMObject *pDDO;

		SearchDICOMObject(DDO, "0010,0020", r);
		strcat(r, ":");
		i += SearchDICOMObject(DDO, desc+i, r+strlen(r));
		if (desc[i]==')') i++;
		//else OperatorConsole.printf("***Syntax error in %V(desc)desc statement %s at %d\n", desc, i);
		pDDO = LoadForGUI(r);
		i += SearchDICOMObject(pDDO, desc+i, result); // no use to allow write to A or O
		delete pDDO;
		return i;
		}

	if (desc[i]=='/') i++, seq=TRUE;
	if (desc[i]=='*') i++, seq=FALSE, wild=TRUE;

	if (isxdig(desc[i]) && desc[i+4]==',') 
	{ g = htoin(desc+i,   4);
  	  e = htoin(desc+i+5, 4);
	  i +=9;
	}
	else if (isalpha(desc[i]))
	{ char d[256]; 
	  int j;
          RTCElement Entry;
	  strcpy(d, desc+i);
	  j=0; while (isalpha(d[j])) j++;
	  d[j]=0;
	  Entry.Description = d;
          if (VRType.GetGroupElement(&Entry))
	  { g = Entry.Group;
            e = Entry.Element;
	    i += j;
	  }
	  else
	    return i;
	}
	else
	  return i;  

	// get plain element
	if (!seq && !wild)
	    	{ 
		if (!DDO) return i;
		vr = DDO->GetVR(g, e);
		if (vr)
			{ 
			if (vr->SQObjectArray)
				{
				if (A) *A = (Array<DICOMDataObject*>*) vr->SQObjectArray;
				strcpy(result, "(sequence)");
				}
			else if (vr->Length>255)
				strcpy(result, "(too long)");
			else
				{
				UINT16 TypeCode = VRType.RunTimeClass(g, e, NULL);
				if      (TypeCode== 'UL') sprintf(result, "%u", (unsigned int)(*(UINT32*)(vr->Data)));
				else if (TypeCode== 'US') sprintf(result, "%u", (unsigned int)(*(UINT16*)(vr->Data)));
				else if (TypeCode== 'SL') sprintf(result, "%d", (int)(*(INT32*)(vr->Data)));
				else if (TypeCode== 'SS') sprintf(result, "%d", (int)(*(INT16*)(vr->Data)));
				else
				{ strncpy(result, (char*)vr->Data, vr->Length);
  	                	  result[vr->Length] = 0;
  	                	  if (vr->Length==0) result[vr->Length+1] = 1; // indicates empty string
				}
  	                	len = vr->Length - 1;
                        	while(len>0)
					{ 
					if (result[len] == ' ')
  	                  			result[len] = 0;
                          		else
                            			break;
                          		len--;
                        		}
				}
                      	}

		return i;
		}

	// get specified sequence element
	else if (seq)
	    	{ 
		int j=0;

		if (desc[i]=='.') 
			{
			i++;
			Index = atoi(desc+i);
			while (isdigit(desc[i])) i++;
			}
		else
			Index = 0;

		vr = NULL;
		if (DDO) vr = DDO->GetVR(g, e);
		if (vr)
			{ 
			if ( vr->SQObjectArray )
				{
				Array < DICOMDataObject * > *ADDO =
					(Array<DICOMDataObject*>*) vr->SQObjectArray;

				j = 0;
				if (desc[i]==0)
					{
					strcpy(result, "(sequence)");
					if (A) *A = ADDO;
					}
				else if (Index<ADDO->GetSize())
					{
					if (O) *O = ADDO->Get(Index);
					j = SearchDICOMObject(ADDO->Get(Index), desc+i, result, A, O);
					}
				}
			else
				{
				if (vr->Length>255)
					strcpy(result, "(too long)");
				else
					{
					UINT16 TypeCode = VRType.RunTimeClass(g, e, NULL);
					if      (TypeCode== 'UL') sprintf(result, "%u", (unsigned int)(*(UINT32*)(vr->Data)));
					else if (TypeCode== 'US') sprintf(result, "%u", (unsigned int)(*(UINT16*)(vr->Data)));
					else if (TypeCode== 'SL') sprintf(result, "%d", (int)(*(INT32*)(vr->Data)));
					else if (TypeCode== 'SS') sprintf(result, "%d", (int)(*(INT16*)(vr->Data)));
					else
					{ strncpy(result, (char*)vr->Data, vr->Length);
  	                		  result[vr->Length] = 0;
  	                	  	  if (vr->Length==0) result[vr->Length+1] = 1;  // indicates empty string
					}
  	        	        	len = vr->Length - 1;
                        		while(len>0)
						{ 
						if (result[len] == ' ')
  		                  			result[len] = 0;
                	          		else
                        	    			break;
                          			len--;
                        			}
					}
                      		}
			}
		else
			{
			// ignore rest of desc
			char dum[1024];
			j = SearchDICOMObject(DDO, desc+i, dum);
			}

		return i+j;
		}
	
	// wild: search all sequences
	if (!DDO) return i;
	while((vr=DDO->Pop()))
		{
		if (*result==0)
			{ 
			if ( vr->SQObjectArray )
				{
				Array < DICOMDataObject * > *ADDO =
					(Array<DICOMDataObject*>*) vr->SQObjectArray;
				
				Index = 0;
				while ( Index < ADDO->GetSize() )
					{
					SearchDICOMObject(ADDO->Get(Index), desc, result);
					if (*result) break;
					++Index;
					}
				}
			else if (vr->Group==g && vr->Element==e)
				{
				if (vr->Length>255)
					strcpy(result, "(too long)");
				else
					{
					UINT16 TypeCode = VRType.RunTimeClass(g, e, NULL);
					if      (TypeCode== 'UL') sprintf(result, "%u", (unsigned int)(*(UINT32*)(vr->Data)));
					else if (TypeCode== 'US') sprintf(result, "%u", (unsigned int)(*(UINT16*)(vr->Data)));
					else if (TypeCode== 'SL') sprintf(result, "%d", (int)(*(INT32*)(vr->Data)));
					else if (TypeCode== 'SS') sprintf(result, "%d", (int)(*(INT16*)(vr->Data)));
					else
					{ strncpy(result, (char*)vr->Data, vr->Length);
  	                		  result[vr->Length] = 0;
	  	                	  if (vr->Length==0) result[vr->Length+1] = 1;  // indicates empty string
					}
  	                		len = vr->Length - 1;
	                        	while(len>0)
						{ 
						if (result[len] == ' ')
  	                	  			result[len] = 0;
                          			else
                            				break;
	                          		len--;
        	                		}
					}
				}
			}

		DDO2.Push(vr);
		}

	DDO->Reset();
	while((vr=DDO2.Pop()))
		{
		DDO->Push(vr);
		}

	return i;
	}


/////////////////////////////////////////////////////////////////////////////////////////////////
// lua integration
/////////////////////////////////////////////////////////////////////////////////////////////////

char *heapinfo( void );
static BOOL DcmMove2(char* pszSourceAE, const char* pszDestinationAE, BOOL patroot, int id, DICOMDataObject *DDO, const char *callback);

#include "lua.hpp"

struct scriptdata
{ ExtendedPDU_Service *PDU;
  DICOMCommandObject *DCO;
  DICOMDataObject *DDO;
  int  N;
  char *pszModality;
  char *pszStationName;
  char *pszSop;
  char *patid;
  char *Storage;
  int  rc;
} sd1;

extern "C"
{ struct scriptdata *getsd(lua_State *L)
  { lua_getglobal(L, "scriptdata");
    struct scriptdata *sd = (struct scriptdata *)lua_topointer(L, -1);
    lua_pop(L, 1);
    return sd;
  }
  static void luaCreateObject(lua_State *L, DICOMDataObject *pDDO, Array < DICOMDataObject *> *A, BOOL owned);
  
  static int _luaprint(lua_State *L, Debug *d)
  { int i, n=lua_gettop(L);
    char text[2000]; text[0]=0;
    for (i=1; i<=n; i++)
    { if (i>1)                     sprintf(text + strlen(text), "\t");
      if (lua_isstring(L,i))       sprintf(text + strlen(text), "%s",lua_tostring(L,i));
      else if (lua_isnil(L,i))     sprintf(text + strlen(text), "%s","nil");
      else if (lua_isboolean(L,i)) sprintf(text + strlen(text), "%s",lua_toboolean(L,i) ? "true" : "false");
      else                         sprintf(text + strlen(text), "%s:%p",luaL_typename(L,i),lua_topointer(L,i));
    }
    d->printf("%s\n", text);
    return 0;
  }
  static int luaprint(lua_State *L)    { return _luaprint(L, &OperatorConsole); }
  static int luadebuglog(lua_State *L) { return _luaprint(L, &SystemDebug);     }
  static int luaservercommand(lua_State *L)
  { int n=lua_gettop(L);
    char buf[2000];
    buf[0]=0;
    if (lua_isstring(L,1)) SendServerCommand("", lua_tostring(L,1), 0, buf);
    if (buf[0]) { lua_pushstring(L, buf); return 1; }
    return 0;
  }
  static int luadictionary(lua_State *L)
  { if (lua_gettop(L)==2)
    { int g = lua_tointeger(L,1);
      int e = lua_tointeger(L,2);
      char s[256]; s[0] = '\0';
      if (VRType.RunTimeClass(g, e, s))
      { lua_pushstring(L, s);
      	return 1;
      }
    }
    else if (lua_gettop(L)==1)
    { RTCElement Entry;
      char s[256];
      strcpy(s, lua_tostring(L, 1));
      Entry.Description = s;
      if (VRType.GetGroupElement(&Entry))
      { lua_pushinteger(L, Entry.Group);
        lua_pushinteger(L, Entry.Element);
        return 2;
      }
    }
    return 0;
  }
  static int luascript(lua_State *L)
  { struct scriptdata *sd = getsd(L);
    int n=lua_gettop(L);
    char cmd[2000]="";
    DICOMDataObject *pDDO;
    pDDO = sd->DDO;
    if (n>0)
    { if (lua_isuserdata(L, 1)) 
      { lua_getmetatable(L, 1);
          lua_getfield(L, -1, "DDO");  pDDO = (DICOMDataObject *) lua_topointer(L, -1); lua_pop(L, 1);
        lua_pop(L, 1);
      }
      else if (lua_isstring(L,1)) 
      	strcpy(cmd, lua_tostring(L,1));
    }
    if (n>1 && lua_isstring(L,2)) 
      strcpy(cmd, lua_tostring(L,2));
    sd->rc = CallImportConverterN(pDDO, -1, sd->pszModality, sd->pszStationName, sd->pszSop, sd->patid, sd->PDU, sd->Storage, cmd);
    return 0;
  }
  static int luaget_amap(lua_State *L)
  { int r = lua_tointeger(L, 1);
    if (r < ACRNemaAddressArray.GetSize())
    { ACRNemaAddress	*AAPtr = ACRNemaAddressArray.Get(r);
      lua_pushstring(L, AAPtr->Name);
      lua_pushstring(L, AAPtr->IP);
      lua_pushstring(L, AAPtr->Port);
      lua_pushstring(L, AAPtr->Compress);
      return 4;
    }
    return 0;
  }
  static int luadbquery(lua_State *L)
  { unsigned int i, N, flds=1;
    const char *items[4];
    SQLLEN SQLResultLength;
    for (i=0; i<4; i++) items[i]=lua_tostring(L,i+1);
    if (items[1]) for (i=0; i<strlen(items[1]); i++) if (items[1][i]==',') flds++;
    if (items[2]) if (*items[2]==0) items[2]=NULL;
    if (items[3]) if (*items[3]==0) items[3]=NULL;
    if (items[4]) if (*items[4]==0) items[4]=NULL;

    Database DB;
    if (DB.Open ( DataSource, UserName, Password, DataHost ) )
    { char fld[48][256]; memset(fld, 0, sizeof(fld));
      DB.Query(items[0], items[1], items[2], items[3]);
      for (i=0; i<flds; i++) DB.BindField (i+1, SQL_C_CHAR, fld[i], 255, &SQLResultLength);
      N = 1; lua_newtable(L);
      while (DB.NextRecord())
      { lua_newtable(L);
        for (i=0; i<flds; i++) { lua_pushstring(L, fld[i]); lua_rawseti(L, -2, i+1); }
	lua_rawseti(L, -2, N++);
	memset(fld, 0, sizeof(fld));
      }
      DB.Close();
      QueryFromGui++;
      return 1;
    }
    return 0;
  }
  static int luasql(lua_State *L)
  { const char *sql = lua_tostring(L,1);

    Database DB;
    if (DB.Open ( DataSource, UserName, Password, DataHost ) )
    { DB.Exec(sql);
      DB.Close();
      QueryFromGui++;
    }
    return 0;
  }
  static int luadicomquery(lua_State *L)
  { const char *ae    = lua_tostring(L,1);
    const char *level = lua_tostring(L,2);
    if (lua_isuserdata(L, 3)) 
    { DICOMDataObject *O = NULL;
      lua_getmetatable(L, 3);
        lua_getfield(L, -1, "DDO");  O = (DICOMDataObject *) lua_topointer(L, -1); lua_pop(L, 1);
      lua_pop(L, 1);
      Array < DICOMDataObject * > *A = new Array < DICOMDataObject * >;
      luaCreateObject(L, NULL, A, TRUE); 
      if (O) VirtualQuery(O, level, 0, A, (char *)ae);
      return 1;
    }
    return 0;
  }
  static int luadicommove(lua_State *L)
  { const char *source = lua_tostring(L,1);
    const char *dest   = lua_tostring(L,2);
    if (lua_isuserdata(L, 3)) 
    { DICOMDataObject *O = NULL;
      lua_getmetatable(L, 3);
        lua_getfield(L, -1, "DDO");  O = (DICOMDataObject *) lua_topointer(L, -1); lua_pop(L, 1);
      lua_pop(L, 1);
      DcmMove2((char *)source, dest, lua_tointeger(L,4), 0x555, O, lua_tostring(L,4));
    }
    return 0;
  }

  static int getptr(lua_State *L, unsigned int *ptr, int *veclen, int *bytes, int *count, int *step, VR **vr, int mode)
  { struct scriptdata *sd = getsd(L); //mode:0,1,2=pixel,row,col
    int pars=lua_gettop(L), n, x=0, y=0, z=0, rows, cols, frames, vec;
    Array < DICOMDataObject *> *pADDO;
    DICOMDataObject *pDDO;
    *veclen = 0;
    n=1;
    pDDO = sd->DDO;
      
    if (pars>0)
    { if (lua_isuserdata(L, n)) 
      { lua_getmetatable(L, n);
          lua_getfield(L, -1, "DDO");  pDDO = (DICOMDataObject *) lua_topointer(L, -1); lua_pop(L, 1);
        lua_pop(L, 1);
        n++; pars--;
      }
    }

    if (pars>0 && (mode==0 || mode==2)) x = lua_tointeger(L,n++), pars--;
    if (pars>0 && (mode==0 || mode==1)) y = lua_tointeger(L,n++), pars--;
    if (pars>0                        ) z = lua_tointeger(L,n++), pars--;

    vec   = pDDO->GetUINT16(0x0028,0x0002);
    rows  = pDDO->GetUINT16(0x0028, 0x0010); if (!rows) return 0;
    cols  = pDDO->GetUINT16(0x0028, 0x0011); if (!cols) return 0;
    if (pDDO->GetUINT16(0x0028, 0x0006)>1)              return 0;
    frames= pDDO->Getatoi(0x0028, 0x0008);
    *bytes = (pDDO->GetUINT16(0x0028, 0x0101)+7)/8;
    *ptr   = (y * cols + x) * vec;
    DecompressNKI(pDDO);
    *vr    = pDDO->GetVR(0x7fe0, 0x0010); if (!vr)   return 0;
    pADDO = (Array<DICOMDataObject*>*)(*vr)->SQObjectArray;
    if (pADDO==NULL)
    { *ptr += z*rows * cols * vec;
      if (*ptr * *bytes > (*vr)->Length) return 0;
    }
    else
    { if (z>=pADDO->GetSize()-1) return 0;
      *vr = pADDO->Get(z+1)->GetVR(0x7fe0, 0x0010);
      if (*ptr * *bytes > (*vr)->Length) return 0;
    }
    if (mode==2) *step = cols; else *step  = 1;
    if (mode==2) *count= rows; else *count = cols;
    *veclen = vec;
    return n;
  }
  static int luagetpixel(lua_State *L)
  { int veclen, count, step, bytes;
    unsigned int ptr;
    VR *vr;
    getptr(L, &ptr, &veclen, &bytes, &count, &step, &vr, 0);
    if (veclen==0) return 0;
    switch(bytes)
    { case 1: for (int i=0; i<veclen; i++) lua_pushinteger(L, *((BYTE   *)(vr->Data)+ptr+i*step)); break;
      case 2: for (int i=0; i<veclen; i++) lua_pushinteger(L, *((UINT16 *)(vr->Data)+ptr+i*step)); break;
      case 4: for (int i=0; i<veclen; i++) lua_pushinteger(L, *((INT32  *)(vr->Data)+ptr+i+step)); break;
      default:for (int i=0; i<veclen; i++) lua_pushinteger(L,                                  0); break;
    }
    return veclen;
  }
  static int luasetpixel(lua_State *L)
  { int pars=lua_gettop(L), veclen, count, step, bytes, n;
    unsigned int ptr;
    VR *vr;
    n=getptr(L, &ptr, &veclen, &bytes, &count, &step, &vr, 0);
    if (veclen==0) return 0;
    if (veclen>pars-n+1) veclen=pars-n+1;
    switch(bytes)
    { case 1: for (int i=0; i<veclen; i++) *((BYTE   *)(vr->Data)+ptr+i*step) = lua_tointeger(L,n++); break;
      case 2: for (int i=0; i<veclen; i++) *((UINT16 *)(vr->Data)+ptr+i*step) = lua_tointeger(L,n++); break;
      case 4: for (int i=0; i<veclen; i++) *((INT32  *)(vr->Data)+ptr+i*step) = lua_tointeger(L,n++); break;
    }
    return 0;
  }
  static int luagetrow(lua_State *L)
  { int veclen, count, step, bytes;
    unsigned int ptr;
    VR *vr;
    getptr(L, &ptr, &veclen, &bytes, &count, &step, &vr, 1);
    if (veclen==0) return 0;
    lua_newtable(L);
    for(int x=0; x<count; x++)
    { switch(bytes)
      { case 1: for (int i=0; i<veclen; i++) {lua_pushinteger(L, *((BYTE   *)(vr->Data)+ptr+i)); lua_rawseti(L, -2, x*veclen+i);} break;
        case 2: for (int i=0; i<veclen; i++) {lua_pushinteger(L, *((UINT16 *)(vr->Data)+ptr+i)); lua_rawseti(L, -2, x*veclen+i);} break;
        case 4: for (int i=0; i<veclen; i++) {lua_pushinteger(L, *((INT32  *)(vr->Data)+ptr+i)); lua_rawseti(L, -2, x*veclen+i);} break;
      }
      ptr += step*veclen;
    }
    return 1;
  }
  static int luagetcolumn(lua_State *L)
  { int veclen, count, step, bytes;
    unsigned int ptr;
    VR *vr;
    getptr(L, &ptr, &veclen, &bytes, &count, &step, &vr, 2);
    if (veclen==0) return 0;
    lua_newtable(L);
    for(int x=0; x<count; x++)
    { switch(bytes)
      { case 1: for (int i=0; i<veclen; i++) {lua_pushinteger(L, *((BYTE   *)(vr->Data)+ptr+i)); lua_rawseti(L, -2, x*veclen+i);} break;
        case 2: for (int i=0; i<veclen; i++) {lua_pushinteger(L, *((UINT16 *)(vr->Data)+ptr+i)); lua_rawseti(L, -2, x*veclen+i);} break;
        case 4: for (int i=0; i<veclen; i++) {lua_pushinteger(L, *((INT32  *)(vr->Data)+ptr+i)); lua_rawseti(L, -2, x*veclen+i);} break;
      }
      ptr += step*veclen;
    }
    return 1;
  }
  static int luasetrow(lua_State *L)
  { int pars=lua_gettop(L), veclen, count, step, bytes, n;
    unsigned int ptr;
    VR *vr;
    n=getptr(L, &ptr, &veclen, &bytes, &count, &step, &vr, 1);
    if (veclen==0 || n>pars) return 0;
    for(int x=0; x<count; x++)
    { switch(bytes)
      { case 1: for (int i=0; i<veclen; i++) {lua_rawgeti(L, pars, x*veclen+i); *((BYTE   *)(vr->Data)+ptr+i) = lua_tointeger(L,-1); lua_pop(L, 1); } break;
	case 2: for (int i=0; i<veclen; i++) {lua_rawgeti(L, pars, x*veclen+i); *((UINT16 *)(vr->Data)+ptr+i) = lua_tointeger(L,-1); lua_pop(L, 1); } break;
	case 4: for (int i=0; i<veclen; i++) {lua_rawgeti(L, pars, x*veclen+i); *((INT32  *)(vr->Data)+ptr+i) = lua_tointeger(L,-1); lua_pop(L, 1); } break;
      }
      ptr += step*veclen;
    }
    return 1;
  }
  static int luasetcolumn(lua_State *L)
  { int pars=lua_gettop(L), veclen, count, step, bytes, n;
    unsigned int ptr;
    VR *vr;
    n=getptr(L, &ptr, &veclen, &bytes, &count, &step, &vr, 2);
    if (veclen==0 || n>pars) return 0;
    for(int x=0; x<count; x++)
    { switch(bytes)
      { case 1: for (int i=0; i<veclen; i++) {lua_rawgeti(L, pars, x*veclen+i); *((BYTE   *)(vr->Data)+ptr+i) = lua_tointeger(L,-1); lua_pop(L, 1); } break;
	case 2: for (int i=0; i<veclen; i++) {lua_rawgeti(L, pars, x*veclen+i); *((UINT16 *)(vr->Data)+ptr+i) = lua_tointeger(L,-1); lua_pop(L, 1); } break;
	case 4: for (int i=0; i<veclen; i++) {lua_rawgeti(L, pars, x*veclen+i); *((INT32  *)(vr->Data)+ptr+i) = lua_tointeger(L,-1); lua_pop(L, 1); } break;
      }
      ptr += step*veclen;
    }
    return 1;
  }

  // getvr(Object, group, element) returns table for normal VR, addo for sequence
  static int luagetvr(lua_State *L)
  { VR *vr;
    if (lua_isuserdata(L,1)) 
    { DICOMDataObject *O = NULL;
      lua_getmetatable(L, 1);
        lua_getfield(L, -1, "DDO");  O = (DICOMDataObject *) lua_topointer(L, -1); lua_pop(L, 1);
      lua_pop(L, 1);
      int g = lua_tointeger(L,2);
      int e = lua_tointeger(L,3);
      vr = O->GetVR(g, e);
      if (vr)
      { if (vr->SQObjectArray)
          luaCreateObject(L, NULL, (Array < DICOMDataObject * > *)vr->SQObjectArray, FALSE);
        else
        { lua_newtable(L);
          for(int i=0; i<vr->Length; i++)
          { lua_pushinteger(L, *((BYTE *)(vr->Data)+i)); lua_rawseti(L, -2, i);
          }
        }
        return 1;
      }
    }
    return 0;
  }
  // setvr(Object, group, element, data); if data is a table sets a sip,e VR, if it is an ADDO sets a sequence
  static int luasetvr(lua_State *L)
  { VR *vr;
    if (lua_isuserdata(L,1)) 
    { DICOMDataObject *O = NULL;
      Array < DICOMDataObject * > *A = NULL;
      lua_getmetatable(L, 1);
        lua_getfield(L, -1, "DDO");  O = (DICOMDataObject *) lua_topointer(L, -1); lua_pop(L, 1);
      lua_pop(L, 1);
      int g = lua_tointeger(L,2);
      int e = lua_tointeger(L,3);
      if (lua_isuserdata(L, 4) && O)
      { lua_getmetatable(L, 4);
          lua_getfield(L, -1, "ADDO");  A = (Array < DICOMDataObject * > *) lua_topointer(L, -1); lua_pop(L, 1);
        lua_pop(L, 1);
	if (A)
        { vr = new VR(g, e, 0, (void *) NULL, FALSE);
          O->DeleteVR(vr);
	  delete vr;
	  vr = new VR(g, e, 0, (void *) NULL, FALSE);
          Array < DICOMDataObject * > *SQE  = new Array <DICOMDataObject *>;
	  for (int j=0; j<A->GetSize(); j++)
	  { DICOMDataObject *dd = MakeCopy(A->Get(j)); 
	    SQE->Add(dd);
	  }
	  vr->SQObjectArray = SQE;
          O->Push(vr);
	}
      }
      else if (lua_istable(L, 4) && O)
      { vr = O->GetVR(g, e);
        if (!vr) 
	{ vr = new VR(g, e, 0, (void *) NULL, FALSE);
	  O->Push(vr);
	}
	vr->ReAlloc(lua_objlen(L, 4)+1);
        for(int i=0; i<=lua_objlen(L, 4); i++)
        { lua_rawgeti(L, 4, i); *((BYTE *)(vr->Data)+i) = lua_tointeger(L,-1); lua_pop(L, 1);
	}
      }
    }
    return 0;
  }

  // readdicom(filename) into Data, or readdicom(x, filename)
  static int luareaddicom(lua_State *L)
  { struct scriptdata *sd = getsd(L);
    if (lua_isstring(L,1)) 
    { if (sd->DDO) delete (sd->DDO);
      sd->DDO = LoadForGUI((char *)lua_tostring(L,1));

      lua_getglobal   (L, "Data");  
      lua_getmetatable(L, -1);
        lua_pushlightuserdata(L, sd->DDO); lua_setfield(L, -2, "DDO");
      lua_pop(L, 2);
    }
    else if (lua_isuserdata(L,1)) 
    { DICOMDataObject *O;
      lua_getmetatable(L, 1);
        lua_getfield(L, -1, "DDO");  O = (DICOMDataObject *) lua_topointer(L, -1); lua_pop(L, 1);
        if (O) delete O;
        O = LoadForGUI((char *)lua_tostring(L,2));
        lua_pushlightuserdata(L, O); lua_setfield(L, -2, "DDO");
      lua_pop(L, 1);
    }
    return 0;
  }
  // writedicom(filename), writedicom(Data, filename); Data:writedicom(filename)
  static int luawritedicom(lua_State *L)
  { struct scriptdata *sd = getsd(L);
    if (lua_isstring(L,1) && sd->DDO) 
    { DICOMDataObject *pDDO = MakeCopy(sd->DDO);
      SaveDICOMDataObject((char *)lua_tostring(L,1), pDDO);
      delete pDDO;
    }
    else if (lua_isuserdata(L,1)) 
    { DICOMDataObject *O = NULL;
      lua_getmetatable(L, 1);
        lua_getfield(L, -1, "DDO");  O = (DICOMDataObject *) lua_topointer(L, -1); lua_pop(L, 1);
      lua_pop(L, 1);

      if (O)
      { DICOMDataObject *pDDO = MakeCopy(O);
        SaveDICOMDataObject((char *)lua_tostring(L,2), pDDO);
        delete pDDO;
      }
    }
    return 0;
  }

  // Data:writeheader(filename) or writeheader(filename)
  static int luawriteheader(lua_State *L) 
  { struct scriptdata *sd = getsd(L);
    if (lua_isuserdata(L,1)) 
    { DICOMDataObject *O = NULL;
      lua_getmetatable(L, 1);
        lua_getfield(L, -1, "DDO");  O = (DICOMDataObject *) lua_topointer(L, -1); lua_pop(L, 1);
      lua_pop(L, 1);

      if (O)
      { FILE *f = fopen(lua_tostring(L, 2), "wt");
        if (f) 
        { NonDestructiveDumpDICOMObject(O, f);
          fclose(f);
        }
      }
    }
    else if (lua_isstring(L,1)) 
    { FILE *f = fopen(lua_tostring(L, 1), "wt");
      if (f) 
      { if (sd->DDO) NonDestructiveDumpDICOMObject(sd->DDO, f);
        fclose(f);
      }
    }
    return 0;
  }
  
  // newdicomobject()
  static int luanewdicomobject(lua_State *L)
  { DICOMDataObject *O = new DICOMDataObject;
    luaCreateObject(L, O, NULL, TRUE); 
    return 1;
  }
  
  // newdicomarray()
  static int luanewdicomarray(lua_State *L)
  { Array < DICOMDataObject * > *A = new Array < DICOMDataObject * >;
    luaCreateObject(L, NULL, A, TRUE); 
    return 1;
  }

  // deletedicomobject()
  static int luadeletedicomobject(lua_State *L)
  { struct scriptdata *sd = getsd(L);
    DICOMDataObject *O = NULL;
    int owned;
    Array < DICOMDataObject * > *A = NULL;
    if (lua_isuserdata(L,1)) 
    { lua_getmetatable(L, 1);
        lua_getfield(L, -1, "DDO");   O = (DICOMDataObject *)             lua_topointer(L, -1); lua_pop(L, 1);
        lua_getfield(L, -1, "ADDO");  A = (Array < DICOMDataObject * > *) lua_topointer(L, -1); lua_pop(L, 1);
        lua_getfield(L, -1, "owned"); owned =                             lua_tointeger(L, -1); lua_pop(L, 1);
        lua_pushlightuserdata(L, NULL); lua_setfield(L, -2, "DDO");
        lua_pushlightuserdata(L, NULL); lua_setfield(L, -2, "ADDO");
      lua_pop(L, 1);
    }
    if (owned)
    { if (O && O!=(DICOMDataObject *)(sd->DCO) && O!=sd->DDO) 
        delete O;
      if (A) 
      { for (int i=0; i<A->GetSize(); i++) delete (DICOMDataObject *)(A->Get(i));
        delete A;
      }
    }
    return 0;
  }

  // heap information for leak debugging
  static int luaheapinfo(lua_State *L)
  { lua_pushstring(L, heapinfo());
    return 1;
  }

static void HTML(const char *string, ...);
static int CGI(char *out, const char *name, const char *def);

  static int luaHTML(lua_State *L)
  { char buf[1000];
    int n=lua_gettop(L);
    switch(n)
    { case 1: HTML(lua_tostring(L, 1)); break;
      case 2: HTML(lua_tostring(L, 1), lua_tostring(L, 2)); break;
      case 3: HTML(lua_tostring(L, 1), lua_tostring(L, 2), lua_tostring(L, 3)); break;
      case 4: HTML(lua_tostring(L, 1), lua_tostring(L, 2), lua_tostring(L, 3), lua_tostring(L, 4)); break;
      case 5: HTML(lua_tostring(L, 1), lua_tostring(L, 2), lua_tostring(L, 3), lua_tostring(L, 4), lua_tostring(L, 5)); break;
    }
    return 0;
  }
  static int luaCGI(lua_State *L)
  { char buf[1000];
    int n=lua_gettop(L);
    switch(n)
    { case 1: CGI(buf, lua_tostring(L, 1), ""); break;
      case 2: CGI(buf, lua_tostring(L, 1), lua_tostring(L,2)); break;
    }
    lua_pushstring(L, buf);
    return 1;
  }
  static int luagpps(lua_State *L)
  { char buf[1000];
    int n=lua_gettop(L);
    switch(n)
    { case 1: MyGetPrivateProfileString ( "sscscp", lua_tostring(L,1), "", buf, 256, ConfigFile);
      case 2: MyGetPrivateProfileString ( lua_tostring(L,1), lua_tostring(L,2),"", buf, 256, ConfigFile);
      case 3: MyGetPrivateProfileString ( lua_tostring(L,1), lua_tostring(L,2), lua_tostring(L,3), buf, 256, ConfigFile);
    }
    lua_pushstring(L, buf);
    return 1;
  }

//todo (now read/write directly from dicom.ini): 
//IgnoreOutOfMemoryErrors, ImportExportDragAndDrop, TruncateFieldNames, ForwardAssociationRelease, 
//RetryForwardFailed, UIDPrefix, ForwardAssociationLevel, ForwardAssociationRefreshDelay
//ForwardAssociationCloseDelay, ForwardAssociationRelease, MaximumExportRetries,
//MaximumDelayedFetchForwardRetries, ziptime, NightlyCleanThreshhold, NightlyCleanThreshhold
//OverlapVirtualGet, SendUpperCaseAE, TCPIPTimeOut, PadAEWithZeros
//acrnema.map, dicom.sql, dgatesop.lst, dgate.dic, Database, Patient, Study[i], Series[i], Image[i]

  static int luaGlobalIndex(lua_State *L)
  { int n;
    int *idata=NULL;
    char *sdata=NULL;
    char szRootSC[64], Parameter[512];
    for (n=0;;n++)
    { if (!iglobals[n].data) break;
      if (stricmp(lua_tostring(L,2), iglobals[n].name)==0) idata = iglobals[n].data;
    }
    for (n=0;;n++)
    { if (!sglobals[n].data) break;
      if (stricmp(lua_tostring(L,2), sglobals[n].name)==0) sdata = sglobals[n].data;
    }
    if (MyGetPrivateProfileString(RootConfig, "MicroPACS", RootConfig, szRootSC, 64, ConfigFile))
      MyGetPrivateProfileString(szRootSC, lua_tostring(L,2), "", Parameter, 512, ConfigFile);

    if (idata)      { lua_pushinteger(L, *idata);     return 1; }
    if (sdata)      { lua_pushstring (L,  sdata);     return 1; }
    if (*Parameter) { lua_pushstring (L,  Parameter); return 1; }
    return 0;
  }
  static int luaGlobalNewIndex(lua_State *L)
  { int n, slen;
    int *idata=NULL;
    char *sdata=NULL;
    char szRootSC[64], Parameter[512], script[1024];
    for (n=0;;n++)
    { if (!iglobals[n].data) break;
      if (stricmp(lua_tostring(L,2), iglobals[n].name)==0) idata = iglobals[n].data;
    }
    for (n=0;;n++)
    { if (!sglobals[n].data) break;
      if (stricmp(lua_tostring(L,2), sglobals[n].name)==0) sdata = sglobals[n].data, slen = sglobals[n].len;
    }
    if (MyGetPrivateProfileString(RootConfig, "MicroPACS", RootConfig, szRootSC, 64, ConfigFile))
      MyGetPrivateProfileString(szRootSC, lua_tostring(L,2), "", Parameter, 512, ConfigFile);
    if (*Parameter)
    { sprintf(script, "put_param:%s,%s", lua_tostring(L,2), lua_tostring(L,3));
      SendServerCommand("", script, 0, NULL);
      SendServerCommand("", "read_ini:", 0, NULL);
    }
    else if (idata) *idata = lua_tointeger(L,3);
    else if (sdata) strncpy(sdata, lua_tostring(L,3), slen-1), sdata[slen-1]=0;
    return 0;
  }

  static int luaAssociationIndex(lua_State *L)
  { struct scriptdata *sd = getsd(L);
    char *cdata=NULL;
    int *idata=NULL;
    BYTE buf[64]; buf[0]=0;
    if (strcmp(lua_tostring(L,2), "Calling")==0)     { cdata = (char *)buf; sd->PDU->GetLocalAddress (buf); }
    else if (strcmp(lua_tostring(L,2), "Called")==0) { cdata = (char *)buf; sd->PDU->GetRemoteAddress(buf); }

    if (cdata) while (strlen(cdata)>0 && cdata[strlen(cdata)-1]==' ') cdata[strlen(cdata)-1] = 0;

    if (strcmp(lua_tostring(L,2), "Thread")==0) idata = &(sd->PDU->ThreadNum);
		        
    if (cdata) { lua_pushstring (L,  cdata);  return 1; }
    if (idata) { lua_pushinteger(L, *idata);  return 1; }
    return 0;
  }

  static int luaSeqClosure(lua_State *L)
  { const char *s = lua_tostring(L, lua_upvalueindex(1));
    if (strcmp(s, "Read" )==0)    return luareaddicom(L);
    if (strcmp(s, "Write")==0)    return luawritedicom(L);
    if (strcmp(s, "Dump" )==0)    return luawriteheader(L);
    if (strcmp(s, "SetVR")==0)    return luasetvr(L);
    if (strcmp(s, "GetVR")==0)    return luagetvr(L);
    if (strcmp(s, "GetPixel")==0) return luagetpixel(L);
    if (strcmp(s, "SetPixel")==0) return luasetpixel(L);
    if (strcmp(s, "GetRow")==0)   return luagetrow(L);
    if (strcmp(s, "SetRow")==0)   return luasetrow(L);
    if (strcmp(s, "GetColumn")==0)return luagetcolumn(L);
    if (strcmp(s, "SetColumn")==0)return luasetcolumn(L);
    if (strcmp(s, "Script")==0)   return luascript(L);
    return 0;
  }
  static int luaSeqnewindex(lua_State *L)
  { struct scriptdata *sd = getsd(L);
    char script[1024];

    Array < DICOMDataObject * > *A = NULL;
    DICOMDataObject *O = NULL;
    lua_getmetatable(L, 1);
      lua_getfield(L, -1, "ADDO"); A = (Array < DICOMDataObject * > *)lua_topointer(L, -1); lua_pop(L, 1);
      lua_getfield(L, -1, "DDO");  O = (DICOMDataObject *)            lua_topointer(L, -1); lua_pop(L, 1);
    lua_pop(L, 1);

    // Data.Sequence, e.g., need to write into Data.Sequence.Item
    if (A)
    { if (A->GetSize()>0) 
        O=A->Get(0);
      else 
      { O = new DICOMDataObject; 
        A->Add(O);
      }
    }

    // write into Data.Storage
    if (O==sd->DDO && strcmp(lua_tostring(L,2), "Storage")==0)
    { sprintf(script, "storage %s", lua_tostring(L,3));
      CallImportConverterN(O, -1, sd->pszModality, sd->pszStationName, sd->pszSop, sd->patid, sd->PDU, sd->Storage, script);
    }
    // write into Data.Item, Data.Sequence.Item, or Data.Sequence[N].Item
    else if (O) 
    { // write table: creates empty! sequence
      if (lua_istable(L, 3))
        sprintf(script, "set %s to \"\"", lua_tostring(L,2));
      // write nil: deletes item
      else if (lua_isnil(L, 3))
        sprintf(script, "set %s to nil", lua_tostring(L,2));
       // write string: creates item
      else
        sprintf(script, "set %s to \"%s\"", lua_tostring(L,2), lua_tostring(L,3));
      CallImportConverterN(O, -1, sd->pszModality, sd->pszStationName, sd->pszSop, sd->patid, sd->PDU, sd->Storage, script);
    }

    return 0;
  }
  static int luaSeqindex(lua_State *L)
  { struct scriptdata *sd = getsd(L);
    Array < DICOMDataObject * > *A, *A2;
    DICOMDataObject *O, *O2;
    char buf[2000]; buf[0]=0;

    lua_getmetatable(L, 1);
      lua_getfield(L, -1, "ADDO"); A = (Array < DICOMDataObject * > *)lua_topointer(L, -1); lua_pop(L, 1);
      lua_getfield(L, -1, "DDO");  O = (DICOMDataObject *)            lua_topointer(L, -1); lua_pop(L, 1);
    lua_pop(L, 1);

    // Address sequence
    if (A) 
    { // push table for selected element (Data.Sequence[N], allow new elements in sequence)
      if (isdigit(*lua_tostring(L,2))) 
      { int N = lua_tonumber(L, 2);
        if (N >A->GetSize()) 
        { O2=NULL;
          A2=NULL;
        }
        else 
        { if (N==A->GetSize()) 
	  { DICOMDataObject *D = new DICOMDataObject; A->Add(D);
	  }
          O2=A->Get(N);
          A2=NULL;
        }
      }
      // Address default element 0 (Data.Sequence.Item)
      else if (A->GetSize()>0)
	SearchDICOMObject(A->Get(0), lua_tostring(L,2), buf, &A2, &O2);
    }
    // Address Data.Storage
    // Address listed methods by name, e.g., Data:Write('c:\\x.dcm')
    // or get selected item (Data.Item, Data.Sequence[N].Item)
    else if (O) 
    { if (O==sd->DDO && strcmp(lua_tostring(L,2), "Storage")==0) 
      { lua_pushstring(L, sd->Storage);
        return 1;
      }
      else if (strstr("Write|Read|Dump|GetVR|SetVR|GetPixel|SetPixel|GetRow|SetRow|GetColumn|SetColumn|Script", lua_tostring(L,2))) 
      { lua_pushvalue(L, 2);
	lua_pushcclosure(L, luaSeqClosure, 1);
	return 1;
      }
      else 
	SearchDICOMObject(O, lua_tostring(L,2), buf, &A2, &O2);
    }
    else
    { A2=NULL; O2=NULL;
    }

    // The item is a sequence or sequence element: return a new table (non-gc'd)
    if (A2 || O2)
    { luaCreateObject(L, O2, A2, FALSE);
      return 1;
    }

    // return a read string: empty string coded as \00\01; non-existing element as \00\00
    if (buf[0]) { lua_pushstring(L, buf); return 1; }
    if (buf[1]) { lua_pushstring(L, buf); return 1; }
    return 0;
  }
  static int luaSeqgc(lua_State *L)
  { struct scriptdata *sd = getsd(L);
    DICOMDataObject *O = NULL;
    Array < DICOMDataObject * > *A = NULL;
    int owned;
    lua_getmetatable(L, 1);
      lua_getfield(L, -1, "DDO");  O = (DICOMDataObject *) lua_topointer(L, -1); lua_pop(L, 1);
      lua_getfield(L, -1, "ADDO");  A = (Array < DICOMDataObject * > *) lua_topointer(L, -1); lua_pop(L, 1);
      lua_getfield(L, -1, "owned"); owned =                             lua_tointeger(L, -1); lua_pop(L, 1);
    lua_pop(L, 1);

    if (owned)
    { if (O && O!=(DICOMDataObject *)(sd->DCO) && O!=sd->DDO) delete O;
      if (A) 
      { for (int i=0; i<A->GetSize(); i++) delete (DICOMDataObject *)(A->Get(i));
        delete A;
      }
    }
    return 0;
  }

  static int luaSeqlen(lua_State *L)
  { struct scriptdata *sd = getsd(L);
    DICOMDataObject *O = NULL;
    Array < DICOMDataObject * > *A = NULL;
    lua_getmetatable(L, 1);
      lua_getfield(L, -1, "DDO");  O = (DICOMDataObject *) lua_topointer(L, -1); lua_pop(L, 1);
      lua_getfield(L, -1, "ADDO");  A = (Array < DICOMDataObject * > *) lua_topointer(L, -1); lua_pop(L, 1);
    lua_pop(L, 1);

    if (O) lua_pushinteger(L, 1);
    else if (A) lua_pushinteger(L, A->GetSize());
    return 1;
  }

  static void luaCreateObject(lua_State *L, DICOMDataObject *pDDO, Array < DICOMDataObject *> *A, BOOL owned)
  { lua_newuserdata(L, 0); 
    lua_createtable(L, 0, 0);
    lua_pushcfunction(L, luaSeqindex);    lua_setfield(L, -2, "__index");
    lua_pushcfunction(L, luaSeqnewindex); lua_setfield(L, -2, "__newindex");
    lua_pushcfunction(L, luaSeqgc);       lua_setfield(L, -2, "__gc");
    lua_pushcfunction(L, luaSeqlen);      lua_setfield(L, -2, "__len");
    lua_pushlightuserdata(L, A);          lua_setfield(L, -2, "ADDO");
    lua_pushlightuserdata(L, pDDO);       lua_setfield(L, -2, "DDO");
    lua_pushinteger      (L, (int)owned); lua_setfield(L, -2, "owned");
    lua_setmetatable(L, -2);
  }
}
  
ExtendedPDU_Service globalPDU; // for global script context

const char *do_lua(lua_State **L, char *cmd, struct scriptdata *sd)
{ if (!*L) 
  { *L = lua_open();
    luaL_openlibs (*L);

    lua_register      (*L, "print",         luaprint);
    lua_register      (*L, "script",        luascript);
    lua_register      (*L, "get_amap",      luaget_amap);
    lua_register      (*L, "dbquery",       luadbquery);
    lua_register      (*L, "sql",           luasql);
    lua_register      (*L, "dicomquery",    luadicomquery);
    lua_register      (*L, "dicommove",     luadicommove);
    lua_register      (*L, "debuglog",      luadebuglog);
    lua_register      (*L, "servercommand", luaservercommand);
    lua_register      (*L, "setpixel",      luasetpixel);
    lua_register      (*L, "getpixel",      luagetpixel);
    lua_register      (*L, "getrow",        luagetrow);
    lua_register      (*L, "setrow",        luasetrow);
    lua_register      (*L, "getcolumn",     luagetcolumn);
    lua_register      (*L, "setcolumn",     luasetcolumn);
    lua_register      (*L, "readdicom",     luareaddicom);
    lua_register      (*L, "writedicom",    luawritedicom);
    lua_register      (*L, "writeheader",   luawriteheader);
    lua_register      (*L, "newdicomobject",luanewdicomobject);
    lua_register      (*L, "newdicomarray", luanewdicomarray);
    lua_register      (*L, "deletedicomobject",luadeletedicomobject);
    lua_register      (*L, "getvr",         luagetvr);
    lua_register      (*L, "setvr",         luasetvr);
    lua_register      (*L, "HTML",          luaHTML);
    lua_register      (*L, "CGI",           luaCGI);
    lua_register      (*L, "gpps",          luagpps);
    lua_register      (*L, "heapinfo",      luaheapinfo);
    lua_register      (*L, "dictionary",    luadictionary);
    
    lua_createtable   (*L, 0, 0); 
    lua_createtable   (*L, 0, 0);
    lua_pushcfunction (*L, luaGlobalIndex);    lua_setfield (*L, -2, "__index");
    lua_pushcfunction (*L, luaGlobalNewIndex); lua_setfield (*L, -2, "__newindex");
    lua_setmetatable  (*L, -2);
    lua_setglobal     (*L, "Global");

    lua_createtable(*L, 0, 0); 
    lua_createtable(*L, 0, 0);
    lua_pushcfunction(*L, luaAssociationIndex); lua_setfield(*L, -2, "__index");
    lua_setmetatable(*L, -2);
    lua_setglobal(*L, "Association");  
  }

  luaCreateObject(*L, (DICOMDataObject *)sd->DCO, NULL, FALSE); lua_setglobal(*L, "Command");  
  luaCreateObject(*L,                    sd->DDO, NULL, FALSE); lua_setglobal(*L, "Data");

  lua_pushlightuserdata(*L, sd); 
  lua_setglobal(*L, "scriptdata");

  if (cmd[0]) 
  { if (luaL_loadstring(*L, cmd)) 
    { OperatorConsole.printf("*** lua syntax error %s in '%s'\n", lua_tostring(*L, -1), cmd);
      lua_pop(*L, 1);
      return NULL;
    } 
    else 
    { if (lua_pcall(*L, 0, 1, 0)) 
      { OperatorConsole.printf("*** lua run error %s in '%s'\n", lua_tostring(*L, -1), cmd);
        lua_pop(*L, 1);
        return NULL;
      }
      else
      { if (lua_isstring(*L, -1))
          return lua_tostring(*L, -1);
        else
	  lua_pop(*L, 1);
      }
    }
  }
  return NULL;  
}

void lua_setvar(ExtendedPDU_Service *pdu, char *name, char *value)
{ struct scriptdata sd = {pdu, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL, 0};
  do_lua(&(pdu->L), "", &sd);
  lua_pushstring(pdu->L, value);
  lua_setglobal (pdu->L, name);
}


main ( int	argc, char	*argv[] )
	{
	char	TimeString1[128];
	time_t	TimeOfDay, TimeOfDay2;

	char	szRootSC[64];
	char	szTemp[32];
	int	i;
	BOOL	MissingDict=FALSE;
	char	tempStr[256];
	int	valid_argc, slen;
	struct	stat st;

	char	*query_string = getenv( "CONTENT_LENGTH" );
	if (query_string && *query_string && argc==1) 
		{
		char *ext=strrchr(argv[0], '.');
		DgateCgi(query_string, ext);
		exit(0);
		}

  ConfigMicroPACS();
  LoadKFactorFile((char*)KFACTORFILE);

  MyGetPrivateProfileString ( RootConfig, "MicroPACS", RootConfig, RootSC, 64, ConfigFile);
  MyGetPrivateProfileString ( RootSC, "Dictionary", "", Temp, 64, ConfigFile);
  if (Temp[0]) 
  { VRType.AttachRTC(Temp);
    globalPDU.AttachRTC(&VRType);
    InitACRNemaAddressArray();
  }

      strcpy(temp, buf);
    if (strcmp(temp+strlen(temp)-4, ".lua")==0)
    { struct scriptdata sd1 = {&globalPDU, NULL, NULL, -1, NULL, NULL, NULL, NULL, NULL, 0};
      char script[512]; int i, n;
      strcpy(script, "dofile('");
      for (i=0, n=8; i<strlen(temp); i++)
      { if (temp[i]=='\\')
        { script[n++] = '\\';
          script[n++] = '\\';
	}
	else 
	{ script[n++] = temp[i];
	}
      }
      script[n++] = 0;
      strcat(script, "')");
      OperatorConsole.On();

      lua_setvar(&globalPDU, "query_string",    getenv( "QUERY_STRING"));      
      lua_setvar(&globalPDU, "server_name",     getenv( "SERVER_NAME" ));
      lua_setvar(&globalPDU, "script_name",     getenv( "SCRIPT_NAME" ));
      lua_setvar(&globalPDU, "path_translated", getenv( "PATH_TRANSLATED" ));
      lua_setvar(&globalPDU, "port",            (char *)Port);
      lua_setvar(&globalPDU, "address",         ServerCommandAddress);
      lua_setvar(&globalPDU, "webcodebase",     WebCodeBase);
      lua_setvar(&globalPDU, "webscriptadress", WebScriptAddress);
      lua_setvar(&globalPDU, "extra",           extra);
      lua_setvar(&globalPDU, "version",         DGATE_VERSION);
      lua_setvar(&globalPDU, "mode",            mode);
      lua_setvar(&globalPDU, "uploadedfile",    uploadedfile);
          
      lua_setvar(&globalPDU, "series",          series);
      lua_setvar(&globalPDU, "series2",         series2);
      lua_setvar(&globalPDU, "slice",           slice);
      lua_setvar(&globalPDU, "slice2",          slice2);
      lua_setvar(&globalPDU, "study",           study);
      lua_setvar(&globalPDU, "study2",          study2);
      lua_setvar(&globalPDU, "patid",           patid);
      lua_setvar(&globalPDU, "patid2",          patid2);
      lua_setvar(&globalPDU, "seruid",          seruid);
      lua_setvar(&globalPDU, "studyuid",        studyuid);
      lua_setvar(&globalPDU, "sopuid",          sopuid);
	  
      lua_setvar(&globalPDU, "size",            size);
      lua_setvar(&globalPDU, "dsize",           dsize);
      lua_setvar(&globalPDU, "compress",        compress);
      lua_setvar(&globalPDU, "iconsize",        iconsize);
      lua_setvar(&globalPDU, "graphic",         graphic);
      lua_setvar(&globalPDU, "viewer",          viewer);
      lua_setvar(&globalPDU, "lw",              lw);
      lua_setvar(&globalPDU, "query",           query);
      lua_setvar(&globalPDU, "db",              db);
      lua_setvar(&globalPDU, "source",          source);
      lua_setvar(&globalPDU, "dest",            dest);
      lua_setvar(&globalPDU, "patientidmatch",  patientidmatch);
      lua_setvar(&globalPDU, "patientnamematch",patientnamematch);
      lua_setvar(&globalPDU, "studydatematch",  studydatematch);
      lua_setvar(&globalPDU, "startdatematch",  startdatematch);

      do_lua(&(globalPDU.L), script, &sd1);

      exit(0);
Z